/* extmain.skel include file for extraction
 * $Log: extmain.skel,v $
 * Revision 1.19  1999/11/18 19:30:33  nort
 * Added <math.h> for floor() as generated for conversions
 *
 * Revision 1.18  1995/10/18  02:05:48  nort
 * Changes to nlcon_display()
 *
 * Revision 1.17  1995/10/06  16:40:02  nort
 * Changes to nlcon_disp()
 * Old change to ROWS() and FRACSECS() macros
 *
 * Revision 1.16  1994/08/29  20:29:28  nort
 * Changes for OUI
 *
 * Revision 1.15  1993/09/27  18:55:31  nort
 * Cleaned up RCS log
 * Cleaned up rcsid[] with Watcom pragmas
 * Added #include <string.h> for memcpy prototype.
 *
 * Revision 1.14  1993/05/19  19:04:51  nort
 * Changed OPT_CON_INIT to OPT_CONSOLE_INIT to allow judicious
 * redefinition for TMA.
 */
#include <stdio.h>
#include <string.h>
#include <sys/kernel.h>
#include <unistd.h>
#include <math.h>
#include "oui.h"
#include "dbr.h"
#include "globmsg.h"
#include "msg.h"
#pragma off (unreferenced)
  static char emrcsid[] =
	"$Id: extmain.skel,v 1.19 1999/11/18 19:30:33 nort Exp nort $";
#pragma on (unreferenced)



 typedef unsigned short UINT;


 typedef unsigned char UCHAR;
	unsigned short InjectingInc = 0;


 typedef unsigned long ULONG;
ULONG CHROMtime;
#include "convfunc.h"
#include "ttdriver.h"
#include "defcals.h"

int tt_p4=72;
int tt_p3=48;
int tt_p2=24;
int tt_p1=0;




	
	

	 typedef float adT;
	 typedef float adT_flow;
	 typedef float vdc_chan;
	 typedef float vdc_pow;
	 typedef float adT_pump;

	 typedef float dacMSpr;

	 typedef UINT InjStateT;

float read_atod(int atod_chan) {
	
	unsigned short atod_val;
	float voltage = -99999;

	atod_val = tt_read_atod( atod_chan );
	atod_val = atod_val + 2048;
	atod_val = atod_val & 0xFFF;

	if (atod_val >= 2048)	{
		atod_val = atod_val|(0xF000);
		atod_val=~atod_val;
		++atod_val;
		voltage = -10.0 * ((float) atod_val) / 2048.0;
		//	printf("reading atod channel %i value is negative %i \n",atod_chan, atod_val);
	} else 	{
		voltage = 10.0 * ((float) atod_val) / 2048.0;
	//	printf("reading atod channel %i value is %f \n",atod_chan,voltage);

	}	

	return voltage;
}


float read_temp(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps(voltage);
}


float read_temp12v(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps12v(voltage);
}

float read_ad_value(int address, float R1, float V1, float V0) { 
	float Vx;

	Vx = read_atod(address);

	if (Vx < 0)
		Vx = -Vx;

	return convert_VtoR( Vx, R1, V1, V0 );

}



#include "valves.h"
#include "address.h"





	 typedef unsigned char DigOutWd;
	 typedef DigOutWd DigInWd;



	 typedef short DigBit;
	 typedef DigBit Bit_HI_LO;
	 typedef DigBit Bit_Op_Cl;
	 typedef DigBit Bit_Cl_Op;
	 typedef DigBit Bit_On_Off;
	 typedef DigBit Bit_Off_On;
	 typedef DigBit Bit_Air_Cal;
	 typedef DigBit Bit_offline;


	UCHAR MSDstateS;

int read_dig_in (unsigned short dig_chan)  {
	
	unsigned short dig_val;
	unsigned short address;
	int value;

	address=dig_chan/8;	
	dig_val=tt_read_digital(address);
	address=dig_chan-address*8;
	value=1<<address;
	//	address=pow(2,address);
	dig_val=dig_val&value;
	if (dig_val==0)
		return 0;
	return 1;
}

int read_dig_out(int chan) {

	return read_dig_in(chan+64);
}


int fail_board(int digch) {
	static int fail_toggle = 0;
	
	if (fail_toggle==0) {
		tt_scdc_command(100 + digch);
		fail_toggle = 1;
		return fail_toggle;
	}

	fail_toggle = 0;
	tt_scdc_command(digch);
	return fail_toggle;
}

// used to pulse a digch (hard coded for dig 20 and 21
// and MSDstate 4 and 5).
int trapToggle( int digch ) {
	static int pulse1 = 0;
	static int pulse2 = 0;
	int	pulse, state;
	const int trap1add = 20;
	const int trap2add = 21;

	if (digch == trap1add) {
	 	state = 4;
		pulse = pulse1;
	} else if (digch == trap2add) {
		state = 5;
		pulse = pulse2;
	} else {
		return 0;
	}

	// toggle dig line
	if ( MSDstateS == state ) {
		switch ( pulse ) {
			case 0:		// off, turn on
				tt_scdc_command( 100 + digch );
				pulse = 1;
				break;
			case 1:		// on, turn off
				tt_scdc_command( digch );
				pulse = 0;
				break;
		}
	} else {
		if ( pulse == 1 ) {
			tt_scdc_command( digch );
			pulse = 0;
		}
	}

	if (digch == trap1add)
		pulse1 = pulse;
	else
		pulse2 = pulse;

	return read_dig_out( digch );

}


#include <sys/types.h>
pid_t rs485_proxy;
short Omega485[34];

short OmegaArray( int add ) {
	return Omega485[add];
}



 typedef short OmegaT;

 typedef short OmegaTsp;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include "/home/panther/drivers/smart/smart.h"
#include "regnames.h"
#include "panthermsg.h"

#define 		ECDOFFLINE 		-9999
#define			NUMSECSXAXIS	 150
#define			ELECRATE		0.1			// seconds

pid_t			ECDresp_proxy;

chrom_packet 	ECDresp[MAXDET];

long int 		DetAvgCt1=0, DetAvgCt2=0, DetAvgCt3=0, DetAvgCt4=0,
		 		DetAvgOffline1=0, DetAvgOffline2=0, DetAvgOffline3=0, DetAvgOffline4=0,
	 			ecd_sum1=0, ecd_sum2=0, ecd_sum3=0, ecd_sum4=0,
				ecdA_SF6save=0, ecdA_F11save=0, ecdA_COsave=0, ecdA_PANsave=0;
float			ecdSF6x = 0.0, ecdF11x = 0.0, ecdCOx = 0.0, ecdPANx = 0.0;
int				currPoint[MAXDET];

// function gets the data from shared data array with smart driver
long int GC_Ctr_Pull( int elecADD ) {
	long ecdDATA;
	
	if ( currPoint[elecADD] >= MAXPOINTS ) currPoint[elecADD] = 0;

	// new data
	if ( currPoint[elecADD] < ECDresp[elecADD].numpnts ) {
		ecdDATA = ECDresp[elecADD].resp[currPoint[elecADD]];
		currPoint[elecADD]++;
	} 
	else {
		ecdDATA = ECDOFFLINE;
		currPoint[elecADD] = 0;
		ECDresp[elecADD].numpnts = -1;
	}

	return ecdDATA;	
}




 typedef long GC_Freq;
 typedef long GC_Ctr;

GC_Freq ecdA_SF6, ecdA_F11, ecdA_CO, ecdA_PAN;

 typedef unsigned char UNYBL;


 typedef unsigned long InjFile;

InjFile ITXFileNum;




ULONG CUMSEC;
#include <sys/types.h>
pid_t valco_proxy;
int valvePos[10] = {0,0,3,3,3,3,3,3,3,3};


 typedef short valvT;
 typedef DigBit valvetext;
 typedef DigBit valveMS1text;
 typedef DigBit valveMS2text;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "da_cache.h"
#include "regnames.h"

#define MAXMSDCHANS 	  8		// Max number of MS channels
#define MAXMSDIONS 		 30		// Max number of ions per channel
#define MAXMSDPOINTS 	 30		// Max Number of data points in a second for an ion
#define MSDOFFLINE 	  -9999
#define MSDMISSING	   -999
#define MAXSENDMSG     2000		// max number of chars from the msd server
#define SEPCHARS		":,()"
#define MSDIONFILE		"/home/panther/flight/msd.ions"

pid_t		MSDresp_proxy;

long int 	MSD_Data_Array[MAXMSDCHANS][MAXMSDPOINTS],
			MSD_Time_Array[MAXMSDPOINTS],
			msdTIMEoldPlot,
			MSchanAvg[MAXMSDCHANS],
			msd_sum[MAXMSDCHANS],
			MSD_ChanX;

unsigned int 	currMSDPoint[MAXMSDCHANS],
				chanInc;

unsigned char 	MSDresp[MAXSENDMSG];		// data returned by msd

struct MSwindow {
	float	ion;			// ion number
	float	dwell;			// dwell time (0 < dwell <= 1) (fraction of a second)
} MStable[MAXMSDCHANS][MAXMSDIONS];


int ReadMSDionFile ( char *IONFILE ) {
	FILE 	*fp;
	char 	buffer[1000];
	char 	*p;
	char	tmp[1];
	int		chan, inc;
	static char	once;
	double	ion, dwell;

	if (once == 1) return 0;

	fp = fopen(	IONFILE, "r" );
	if (fp == NULL) {
		fprintf(stderr, "Open failed: Cannont find %s\n", IONFILE);
		return -1;
	} else {
		while ( fgets( buffer, 1000, fp ) != NULL ) {

			// First strip out the MS channel number
			p = strstr( strlwr(buffer), "mschan" );
			strncpy(tmp, p + strlen("MSchan"), 1);
			chan = atoi(tmp);
			if (chan >= MAXMSDCHANS)
				break;
		
			// Next strip out the ions and dwell times
			p =	strtok(buffer, SEPCHARS );
			inc = 0;
			while ( p != NULL ) {

				if ( strstr(strlwr(p), "null") != NULL ) {
					MStable[chan][inc].ion = 0;
					MStable[chan][inc].dwell = 0;
					inc++;
				} else {
					ion = atof(p);
					if (ion >= 1) { 		// found ion
						p = strtok( NULL, SEPCHARS );
						dwell = atof(p);
						if (( dwell <= 1 ) && ( dwell > 0 )) {
							MStable[chan][inc].ion = ion;
							MStable[chan][inc].dwell = dwell;
							//printf ("%d,%d: %f %f\n", chan, inc, ion, dwell);
						} else {
							MStable[chan][inc].ion = 0;
							MStable[chan][inc].dwell = 0;
							fprintf(stderr, "Bad dwell time for channel %d, ion %f\n", chan, ion);
						}

						inc++;
					} else {
						MStable[chan][inc].ion = 0;
						MStable[chan][inc].dwell = 0;
						//printf("null ion: chan = %d, inc = %d\n", chan,inc);
					}

				}

				p = strtok( NULL, SEPCHARS );
			}
		}
	}

	fclose(fp);
	once = 1;

	return 0;

}

// Function takes a ion number and returns the MS channel number for
// a given time window.
int ion2chan( int win, float ion ) {

	int ch;
	float tol = 0.001;

	// Out of range variable
	if (win > MAXMSDIONS)
		return -1;

	// Scan MStable array for match
	for(ch=0; ch < MAXMSDCHANS; ch++) {
		if (((MStable[ch][win].ion - tol) < ion) && ((MStable[ch][win].ion + tol) > ion))
			return ch;
	}

	// No match in this time window
	return -1;

}

// Functions to pull data from MSD_Data and Time arrays.
long int MSD_Chan_Pull( int chan, int type ) {
	long msdDATA;
	static long msdTIMEold;

	if (currMSDPoint[chan] > MAXMSDPOINTS) 
		currMSDPoint[chan] = MAXMSDPOINTS;

	// type 0 is msd resp data, type 1 is msd time data.
	if ( type == 0 ) {
		msdDATA = MSD_Data_Array[chan][currMSDPoint[chan]];
		currMSDPoint[chan]++;
	} 
	else if ( type == 1 ) {		// real time displayed on text string.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEold;
		else
			msdTIMEold = msdDATA;
	}
	else if ( type == 2 ) {		// this time needs to be monitonically increasing for rtg.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEoldPlot++;
		else if ( msdDATA <= msdTIMEoldPlot ) {
			if ( msdDATA > msdTIMEoldPlot )
				msdDATA = msdDATA + 10;	
			else
				msdDATA = msdTIMEoldPlot + 10;
		}
		msdTIMEoldPlot = msdDATA;
	}

	return msdDATA;	
}




 typedef unsigned short WinNum;

 typedef long MSD_DataType;

MSD_DataType msdA_0, msdA_1, msdA_2, msdA_3, msdA_4, msdA_5, msdA_6, msdA_7, msdA_8;

int MSD_load( unsigned short IonWinNum ) {

	char *p;
	unsigned int chaninc[MAXMSDCHANS], inc, i, c;
	int chan = 0;
	float ion;

	// Initialize global currMSDPoint to 0
	for(c=0; c < MAXMSDCHANS; c++) {
		chaninc[c] = 0;
		currMSDPoint[c] = 0;
	}

	// Fills in MSD_Data_Array with "missing" data MSDMISSING
	for(i=0; i < MAXMSDPOINTS; i++) {
		for(c=0; c < MAXMSDCHANS; c++) {
			MSD_Data_Array[c][i] = MSDMISSING;
			if (c == 0)
				MSD_Time_Array[i] = MSDMISSING;
		}
	}

	// Parse data returned in string MSDresp
	p = strtok(MSDresp, ",");
	inc = 0;
	while( p != NULL ) {

		// Get ion number
		if ( (inc % 3) == 0 ) {
			ion = atof(p);
			chan = ion2chan(IonWinNum, ion);
			// printf("ion = %f, chan = %d\n", ion, chan);
		} 

		// response data
		else if ( (inc % 3) == 1 ) {
			// Set data array
			if ((chan >= 0) && (chan < MAXMSDCHANS)) {
				MSD_Data_Array[chan][chaninc[chan]] = atol(p);
				chaninc[chan]++;
				if (chaninc[chan] > MAXMSDPOINTS) {
					chaninc[chan] = MAXMSDPOINTS;
					break;
				}
			}
		} 

		// time data
		else if ( (inc % 3) == 2 ) {
			if (chan == 0)
				MSD_Time_Array[chaninc[chan] - 1] = atol(p);
		} 

		p = strtok(NULL, ",");
		inc++;
	}

	// Set MSDresp array to 0
	for (i=0; i<MAXSENDMSG; i++) 
		MSDresp[i] = '\0';
	
	return 1;

}		



	unsigned short InjectingInc_MSD = 0;


ULONG MSDchromtime;
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include "regnames.h"

#define MAXMON 	19		// should match number in msd driver

pid_t	MSDeng_proxy;
float 	MSDeng[MAXMON];

void InitializeMSDeng() {
	int param;
	static char once;

	if (once == 1) return;

	for (param=0; param<MAXMON; param++)
		MSDeng[param] = -99.0;

	once = 1;

}




 typedef double MSDdouble;
#include <sys/types.h>
#include "maycomm.h"
pid_t maycomm_proxy = 0;

TDLstruct tdl;

#define USELONGPATH  900	// use the long path TDL when less than 900 ppm
#define OffsetShortPath  5   // Offset to match long and short at switch
int P;



 typedef float tdlfloat;
 typedef float tdlfloas;
 typedef short tdlint6; /* edf2ext.awk reading eng.edf */
  #include <stdlib.h>
  #include "ssp.h"
  #include "tmctime.h"

  #define Ct24_Long(x) (0xFFFFFF & *(TMLONG *)&x)
  #define Ct24_Double(x) (double)Ct24_Long(x)
  #define To_Double(x) (double)(x)
  #define EXTRACTION_INIT initialize()
  #define EXTRACTION_TERM terminate()
  #define ALL_SPSS

  static double ext_delta = 0.;

  static sps_ptr edf_ss_open( char *name, int width ) {
	sps_ptr ss;

	ss = ss_open( name );
	if ( ss_error( ss ) ) {
	  ss = ss_create( name, SPT_INCREASING, width, 0 );
	  if ( ss_error( ss ) )
	    msg( 3, "Unable to create spreadsheet %s", name );
	  errno = 0;
	  msg( 0, "Creating spreadsheet %s.sps", name );
	} else if ( ss_width( ss ) != width )
	  msg( 3,
	    "Existing spreadsheet %s.sps not of width %d", width );
	else msg( 0, "Appending to spreadsheet %s.sps", name );
	return ss;
  }

  sps_ptr eng;
  void initialize(void) {
	{
	  char *s;
	  s = getenv("EXT_DELTA");
	  if (s != NULL) {
		ext_delta=atof(s);
		msg(MSG, "Using Time Delta of %lf", ext_delta);
	  }
	}
	eng = edf_ss_open( "eng", 123 );
	ss_set_column(eng, 0, "%14.11lt", "Time");
	ss_set_column(eng, 1, "%12.1f", "FlowM_CO");
	ss_set_column(eng, 2, "%12.1f", "FlowB_CO");
	ss_set_column(eng, 3, "%12.1f", "PresBP_CO");
	ss_set_column(eng, 4, "%12.1f", "PresE_CO");
	ss_set_column(eng, 5, "%12.1f", "VoltM_CO");
	ss_set_column(eng, 6, "%12.1f", "VoltB_CO");
	ss_set_column(eng, 7, "%12.1f", "VoltBP_CO");
	ss_set_column(eng, 8, "%12.1f", "VoltE_CO");
	ss_set_column(eng, 9, "%12.1f", "FlowM_SF6");
	ss_set_column(eng, 10, "%12.1f", "FlowB_SF6");
	ss_set_column(eng, 11, "%12.1f", "PresBP_SF6");
	ss_set_column(eng, 12, "%12.1f", "PresE_SF6");
	ss_set_column(eng, 13, "%12.1f", "VoltM_SF6");
	ss_set_column(eng, 14, "%12.1f", "VoltB_SF6");
	ss_set_column(eng, 15, "%12.1f", "VoltBP_SF6");
	ss_set_column(eng, 16, "%12.1f", "VoltE_SF6");
	ss_set_column(eng, 17, "%12.1f", "FlowM_F11");
	ss_set_column(eng, 18, "%12.1f", "FlowB_F11");
	ss_set_column(eng, 19, "%12.1f", "PresBP_F11");
	ss_set_column(eng, 20, "%12.1f", "PresE_F11");
	ss_set_column(eng, 21, "%12.1f", "VoltM_F11");
	ss_set_column(eng, 22, "%12.1f", "VoltB_F11");
	ss_set_column(eng, 23, "%12.1f", "VoltBP_F11");
	ss_set_column(eng, 24, "%12.1f", "VoltE_F11");
	ss_set_column(eng, 25, "%12.1f", "Pres1_PAN");
	ss_set_column(eng, 26, "%12.1f", "Pres2_PAN");
	ss_set_column(eng, 27, "%12.1f", "PresSrc_PAN");
	ss_set_column(eng, 28, "%12.1f", "PresE_PAN");
	ss_set_column(eng, 29, "%12.1f", "VoltM_PAN");
	ss_set_column(eng, 30, "%12.1f", "VoltB_PAN");
	ss_set_column(eng, 31, "%12.1f", "FlowSrc_PAN");
	ss_set_column(eng, 32, "%12.1f", "VoltE_PAN");
	ss_set_column(eng, 33, "%12.1f", "PresMS1");
	ss_set_column(eng, 34, "%12.1f", "PresMS2");
	ss_set_column(eng, 35, "%12.1f", "PresBP_5");
	ss_set_column(eng, 36, "%12.1f", "PresE_5");
	ss_set_column(eng, 37, "%12.1f", "VoltMS1");
	ss_set_column(eng, 38, "%12.1f", "VoltMS2");
	ss_set_column(eng, 39, "%12.1f", "VoltBP_5");
	ss_set_column(eng, 40, "%12.1f", "VoltE_5");
	ss_set_column(eng, 41, "%12.1f", "Pres_SL");
	ss_set_column(eng, 42, "%12.1f", "Pres_Inlet");
	ss_set_column(eng, 43, "%12.1f", "PresH_CO2");
	ss_set_column(eng, 44, "%12.1f", "PresH_N2O");
	ss_set_column(eng, 45, "%12.1f", "PresH_ZA");
	ss_set_column(eng, 46, "%12.1f", "PresH_PAN");
	ss_set_column(eng, 47, "%12.1f", "PresH_Cal2");
	ss_set_column(eng, 48, "%12.1f", "PresH_Cal1");
	ss_set_column(eng, 49, "%12.1f", "PresH_He");
	ss_set_column(eng, 50, "%12.1f", "PresH_N2");
	ss_set_column(eng, 51, "%12.1f", "PresL_CO2");
	ss_set_column(eng, 52, "%12.1f", "PresL_N2O");
	ss_set_column(eng, 53, "%12.1f", "PresL_ZA");
	ss_set_column(eng, 54, "%12.1f", "PresL_PAN");
	ss_set_column(eng, 55, "%12.1f", "PresL_Cal2");
	ss_set_column(eng, 56, "%12.1f", "PresL_Cal1");
	ss_set_column(eng, 57, "%12.1f", "PresL_He");
	ss_set_column(eng, 58, "%12.1f", "PresL_N2");
	ss_set_column(eng, 59, "%12.1f", "Temp_F11sl");
	ss_set_column(eng, 60, "%12.1f", "Temp_SF6sl");
	ss_set_column(eng, 61, "%12.1f", "Temp_COsl");
	ss_set_column(eng, 62, "%12.1f", "Temp_GSVbo");
	ss_set_column(eng, 63, "%12.1f", "Temp_elect");
	ss_set_column(eng, 64, "%12.1f", "Temp_PANsl");
	ss_set_column(eng, 65, "%12.1f", "Temp_stack");
	ss_set_column(eng, 66, "%12.1f", "Temp_Ipump");
	ss_set_column(eng, 67, "%12.1f", "F11_Col");
	ss_set_column(eng, 68, "%12.1f", "CO_Col");
	ss_set_column(eng, 69, "%12.1f", "SF6_Col");
	ss_set_column(eng, 70, "%12.1f", "SF6_Post");
	ss_set_column(eng, 71, "%12.1f", "F11_ECD");
	ss_set_column(eng, 72, "%12.1f", "CO_ECD");
	ss_set_column(eng, 73, "%12.1f", "SF6_ECD");
	ss_set_column(eng, 74, "%12.1f", "PAN_ECD");
	ss_set_column(eng, 75, "%12.1f", "Trap1_CB");
	ss_set_column(eng, 76, "%12.1f", "Trap2_CB");
	ss_set_column(eng, 77, "%12.1f", "F11_Col_Sp");
	ss_set_column(eng, 78, "%12.1f", "CO_Col_Sp");
	ss_set_column(eng, 79, "%12.1f", "SF6_Col_Sp");
	ss_set_column(eng, 80, "%12.1f", "SF6_Post_Sp");
	ss_set_column(eng, 81, "%12.1f", "F11_ECD_Sp");
	ss_set_column(eng, 82, "%12.1f", "CO_ECD_Sp");
	ss_set_column(eng, 83, "%12.1f", "SF6_ECD_Sp");
	ss_set_column(eng, 84, "%12.1f", "PAN_ECD_Sp");
	ss_set_column(eng, 85, "%12.1f", "Trap1_CB_Sp");
	ss_set_column(eng, 86, "%12.1f", "Trap2_CB_Sp");
	ss_set_column(eng, 87, "%12.1f", "Pow_p28pri");
	ss_set_column(eng, 88, "%12.1f", "Pow_p28sec");
	ss_set_column(eng, 89, "%12.1f", "Pow_p15pel1");
	ss_set_column(eng, 90, "%12.1f", "Pow_p15pel2");
	ss_set_column(eng, 91, "%12.1f", "Pow_p12");
	ss_set_column(eng, 92, "%12.1f", "Pow_m15");
	ss_set_column(eng, 93, "%12.1f", "Pow_p15");
	ss_set_column(eng, 94, "%12.1f", "Pow_p5");
	ss_set_column(eng, 95, "%12.1f", "Pow_p24gsv");
	ss_set_column(eng, 96, "%12.1f", "Pow_p24ms");
	ss_set_column(eng, 97, "%12.1f", "Flow_MSsl");
	ss_set_column(eng, 98, "%12.1f", "Flow_Packsl");
	ss_set_column(eng, 99, "%12.1f", "Flow_PANsl");
	ss_set_column(eng, 100, "%12.1f", "ecdA_SF6");
	ss_set_column(eng, 101, "%12.1f", "ecdA_F11");
	ss_set_column(eng, 102, "%12.1f", "ecdA_CO");
	ss_set_column(eng, 103, "%12.1f", "ecdA_PAN");
	ss_set_column(eng, 104, "%12.1f", "msdA_0");
	ss_set_column(eng, 105, "%12.1f", "msdA_1");
	ss_set_column(eng, 106, "%12.1f", "msdA_2");
	ss_set_column(eng, 107, "%12.1f", "msdA_3");
	ss_set_column(eng, 108, "%12.1f", "msdA_4");
	ss_set_column(eng, 109, "%12.1f", "msdA_5");
	ss_set_column(eng, 110, "%12.1f", "ColT_MS1");
	ss_set_column(eng, 111, "%12.1f", "ColT_MS2");
	ss_set_column(eng, 112, "%12.1f", "ColT_PAN");
	ss_set_column(eng, 113, "%12.1f", "Trap1_set");
	ss_set_column(eng, 114, "%12.1f", "Trap1_re");
	ss_set_column(eng, 115, "%12.1f", "Trap2_set");
	ss_set_column(eng, 116, "%12.1f", "Trap2_re");
	ss_set_column(eng, 117, "%12.1f", "PresBP_PAN");
	ss_set_column(eng, 118, "%12.1f", "VoltBP_PAN");
	ss_set_column(eng, 119, "%12.1f", "PresHead_P");
	ss_set_column(eng, 120, "%12.1f", "Temp_PANsrc");
	ss_set_column(eng, 121, "%12.1f", "Temp_PANlmp");
	ss_set_column(eng, 122, "%12.1f", "Temp_GasBot");
  }
  void terminate(void) {
	ss_close(eng);
  }

#ifdef CONSOLE_INIT
  #error CONSOLE_INIT is obsolete
#endif
#ifdef MSG_LABEL
  #error MSG_LABEL is obsolete
#endif

#ifdef N_CONSOLES
  #include "nl_cons.h"
  #ifndef DATA_ATTR
	#define DATA_ATTR 7
  #endif

  #define cdisplay(d,r,c,s) nlcon_display(d,r,c,s,DATA_ATTR)
  #define display_(d,r,c,t,v,s) {\
	static t sv_;\
	if (v != sv_) { cdisplay(d,r,c,s); sv_ = v; }\
  }
#endif


unsigned char V0 = 0x1;
unsigned char V1 = 0x1;
unsigned char V2 = 0x1;
unsigned char V3 = 0x1;
unsigned char V4 = 0x1;
unsigned char V5 = 0x1;
unsigned char V6 = 0x1;
unsigned char V7 = 0x1;
unsigned char V8 = 0x1;
unsigned char V9 = 0x1;
unsigned char V10 = 0x3;
unsigned int V11 = 0xFFFF;
unsigned char V12 = 0x7F;
adT PresHead_P;
adT_flow FlowM_CO;
adT_flow FlowB_CO;
adT PresBP_CO;
adT PresE_CO;
vdc_chan VoltM_CO;
vdc_chan VoltB_CO;
vdc_chan VoltBP_CO;
vdc_chan VoltE_CO;
adT_flow FlowM_SF6;
adT_flow FlowB_SF6;
adT PresBP_SF6;
adT PresE_SF6;
vdc_chan VoltM_SF6;
vdc_chan VoltB_SF6;
vdc_chan VoltBP_SF6;
vdc_chan VoltE_SF6;
adT_flow FlowM_F11;
adT_flow FlowB_F11;
adT PresBP_F11;
adT PresE_F11;
vdc_chan VoltM_F11;
vdc_chan VoltB_F11;
vdc_chan VoltBP_F11;
vdc_chan VoltE_F11;
adT Pres1_PAN;
adT Pres2_PAN;
adT PresSrc_PAN;
adT_flow FlowSrc_PAN;
adT PresBP_PAN;
adT PresE_PAN;
vdc_chan VoltM_PAN;
vdc_chan VoltB_PAN;
vdc_chan VoltBP_PAN;
vdc_chan VoltE_PAN;
adT PresMS1;
adT PresMS2;
adT PresBP_5;
adT PresE_5;
vdc_chan VoltMS1;
vdc_chan VoltMS2;
vdc_chan VoltBP_5;
vdc_chan VoltE_5;
adT Trap1_set;
adT Trap1_re;
adT Trap2_set;
adT Trap2_re;
adT ColT_MS1;
adT ColT_MS2;
adT ColT_PAN;
adT Pres_SL;
adT Pres_Inlet;
adT Flow_MSsl;
adT Flow_Packsl;
adT Flow_PANsl;
adT PresH_CO2;
adT PresH_N2O;
adT PresH_ZA;
adT PresH_PAN;
adT PresH_Cal2;
adT PresH_Cal1;
adT PresH_He;
adT PresH_N2;
adT PresL_CO2;
adT PresL_N2O;
adT PresL_ZA;
adT PresL_PAN;
adT PresL_Cal2;
adT PresL_Cal1;
adT PresL_He;
adT PresL_N2;
adT Temp_F11sl;
adT Temp_SF6sl;
adT Temp_COsl;
adT Temp_PANsl;
adT Temp_GSVbo;
adT Temp_elect;
adT Temp_stack;
adT Temp_Ipump;
adT Temp_PANsrc;
adT Temp_GasBot;
adT Temp_PANlmp;
vdc_pow Pow_p28pri;
vdc_pow Pow_p28sec;
vdc_pow Pow_p15pel1;
vdc_pow Pow_p15pel2;
vdc_pow Pow_p12;
vdc_pow Pow_m15;
vdc_pow Pow_p15;
vdc_pow Pow_p5;
vdc_pow Pow_p24gsv;
vdc_pow Pow_p24ms;
OmegaT F11_Col;
OmegaT CO_Col;
OmegaT SF6_Col;
OmegaT F11_ECD;
OmegaT CO_ECD;
OmegaT SF6_ECD;
OmegaT PAN_ECD;
OmegaTsp F11_Col_Sp;
OmegaTsp CO_Col_Sp;
OmegaTsp SF6_Col_Sp;
OmegaTsp F11_ECD_Sp;
OmegaTsp CO_ECD_Sp;
OmegaTsp SF6_ECD_Sp;
OmegaTsp PAN_ECD_Sp;
GC_Ctr GC_Ctr_F11;
GC_Ctr GC_Ctr_CO;
GC_Ctr GC_Ctr_PAN;
tdlfloas tdlP;
tdlfloat tdlsH2O;
tdlfloat tdllH2O;
union {
  struct {
    UINT MFCtr;
    GC_Ctr GC_Ctr_SF6;
    vdc_chan VoltE_CO;
    InjStateT InjState;
    Bit_Op_Cl SLoopMSout;
    vdc_chan VoltB_CO;
    vdc_chan VoltM_CO;
    adT PresE_CO;
    adT PresHead_P;
    UINT CurrFile;
    Bit_Off_On pelt1State;
    UINT CurrInj;
    Bit_HI_LO pilotTrip;
    adT_flow FlowM_SF6;
    adT PresMS1;
    UINT Synch;
  } U0;
  struct {
    char U2[2];
    MSD_DataType MSD_TimePlot;
    vdc_chan VoltE_F11;
    vdc_chan VoltBP_CO;
    vdc_chan VoltBP_SF6;
    vdc_chan VoltB_SF6;
    vdc_chan VoltM_SF6;
    adT PresBP_CO;
    adT_pump rpm_Ipump;
    adT_flow FlowM_CO;
    adT PresMS2;
    adT Trap1_re;
  } U1;
  struct {
    char U4[6];
    vdc_chan VoltE_PAN;
    vdc_chan VoltE_SF6;
    vdc_chan VoltB_F11;
    vdc_chan VoltM_F11;
    adT PresE_F11;
    adT PresE_SF6;
    adT_flow FlowB_CO;
    adT_flow FlowB_SF6;
    adT ColT_MS1;
    adT ColT_MS2;
  } U3;
  struct {
    char U6[6];
    adT Trap1_set;
    vdc_chan VoltBP_F11;
    vdc_chan VoltM_PAN;
    adT_flow FlowSrc_PAN;
    adT PresBP_PAN;
    adT PresBP_F11;
    adT PresBP_SF6;
    adT_flow FlowM_F11;
    adT ColT_PAN;
    adT PresH_N2;
  } U5;
  struct {
    char U8[6];
    adT PresL_N2;
    vdc_chan VoltB_PAN;
    vdc_chan VoltE_5;
    vdc_chan VoltBP_PAN;
    adT PresE_PAN;
    adT PresSrc_PAN;
    adT_flow FlowB_F11;
    adT Pres1_PAN;
    adT PresH_He;
    adT PresL_He;
  } U7;
  struct {
    char U10[6];
    adT Temp_F11sl;
    adT Trap2_re;
    adT Trap2_set;
    vdc_chan VoltBP_5;
    vdc_chan VoltMS2;
    vdc_chan VoltMS1;
    adT Pres2_PAN;
    adT PresBP_5;
    adT PresL_CO2;
    adT Temp_elect;
  } U9;
  struct {
    char U12[6];
    vdc_pow Pow_p28sec;
    adT PresL_N2O;
    adT Pres_Inlet;
    adT Pres_SL;
    dacMSpr PresMS1sp;
    dacMSpr PresMS2sp;
    adT PresE_5;
    adT PresH_CO2;
    adT Temp_COsl;
    vdc_pow Pow_p28pri;
  } U11;
  struct {
    char U14[6];
    Bit_Off_On trap1heat;
    Bit_Off_On trap2heat;
    adT Temp_GasBot;
    adT PresH_N2O;
    adT PresH_PAN;
    adT Flow_PANsl;
    adT Flow_Packsl;
    adT Flow_MSsl;
    adT PresL_Cal2;
    adT Temp_stack;
    vdc_pow Pow_p15pel2;
  } U13;
  struct {
    char U16[6];
    OmegaT SF6_Post;
    OmegaTsp SF6_Post_Sp;
    vdc_pow Pow_p5;
    adT PresL_PAN;
    adT PresL_ZA;
    adT PresH_ZA;
    adT PresH_Cal1;
    adT PresH_Cal2;
    adT Temp_SF6sl;
    vdc_pow Pow_p15pel1;
    vdc_pow Pow_p12;
  } U15;
  struct {
    char U18[6];
    valveMS2text valv_MS2;
    valveMS1text valv_MS1;
    Bit_HI_LO faildummy;
    valvetext valv_CO;
    adT Temp_GSVbo;
    adT Temp_Ipump;
    adT Temp_PANlmp;
    adT Temp_PANsl;
    adT PresL_Cal1;
    vdc_pow Pow_p24gsv;
    vdc_pow Pow_m15;
    vdc_pow Pow_p15;
  } U17;
  struct {
    char U20[6];
    MSD_DataType MSD_Time;
    Bit_Cl_Op SLoopIN;
    WinNum IonWinNum;
    Bit_Cl_Op SLoopOUT;
    OmegaT Trap1_CB;
    Bit_Off_On PANflowCont;
    Bit_Cl_Op PANflsh;
    Bit_Off_On PANlamp;
    Bit_Air_Cal PANsol1;
    Bit_Off_On trap2relay;
    UCHAR GCstate;
    UCHAR MSDstate;
    adT Temp_PANsrc;
    Bit_Off_On pelt2State;
    UINT CurrInj_MSD;
    vdc_pow Pow_p24ms;
    OmegaT F11_ECD;
    OmegaTsp F11_ECD_Sp;
  } U19;
  struct {
    char U22[6];
    MSDdouble msdEEGY;
    OmegaT PAN_ECD;
    OmegaTsp PAN_ECD_Sp;
    OmegaTsp Trap1_CB_Sp;
    Bit_Off_On trap1relay;
    OmegaT CO_Col;
    OmegaTsp CO_Col_Sp;
    Bit_Cl_Op PANsol2;
    Bit_Off_On PANsol3;
    Bit_Op_Cl PANsol4;
    UINT CurrFile_MSD;
    GC_Ctr GC_Ctr_CO;
    OmegaT F11_Col;
    OmegaTsp F11_Col_Sp;
    OmegaT SF6_ECD;
    OmegaTsp SF6_ECD_Sp;
  } U21;
  struct {
    char U24[6];
    MSDdouble msdFSEL;
    valvetext valv_F11;
    valvetext valv_SF6;
    valvT ssv2;
    valvT ssv1;
    OmegaT Trap2_CB;
    OmegaTsp Trap2_CB_Sp;
    OmegaT CO_ECD;
    OmegaTsp CO_ECD_Sp;
    MSD_DataType MSD_Chan0;
    tdlfloas tdlP;
    OmegaT SF6_Col;
    OmegaTsp SF6_Col_Sp;
    GC_Ctr GC_Ctr_PAN;
  } U23;
  struct {
    char U26[6];
    MSDdouble msdEMUL;
    MSD_DataType MSD_Chan4;
    MSD_DataType MSD_Chan3;
    MSD_DataType MSD_Chan2;
    MSD_DataType MSD_Chan1;
    MSDdouble msdECUR;
    GC_Ctr GC_Ctr_F11;
    ULONG maycX;
  } U25;
  struct {
    char U28[6];
    MSDdouble msdMASO;
    MSDdouble msdREP;
    MSDdouble msdIPOL;
    MSDdouble msdAMUO;
    MSDdouble msdAMUG;
  } U27;
  struct {
    char U30[6];
    tdlint6  tdllZer;
    tdlint6  tdllPos;
    valvetext valv_PAN;
    UINT loadMSDarray;
    MSDdouble msdENT;
    MSDdouble msdIFOC;
    MSDdouble msdENTO;
    MSDdouble msdMMW;
  } U29;
  struct {
    char U32[10];
    MSD_DataType MSD_Chan5;
    MSDdouble msdCAL;
    MSDdouble msdHEDEN;
    MSDdouble msdQUAD;
    MSDdouble msdSRCTEMP;
  } U31;
  struct {
    char U34[10];
    tdlint6  tdllPow;
    tdlint6  tdllAmp;
    MSDdouble msdMASG;
    MSDdouble msdTURBOPCT;
    tdlfloas tdlT;
    tdlfloat tdlbH2O;
  } U33;
  struct {
    char U36[14];
    tdlint6  tdlsZer;
    tdlint6  tdlsPos;
    tdlint6  tdlsPow;
    tdlint6  tdlsAmp;
    tdlfloat tdllH2O;
    tdlfloat tdlsH2O;
  } U35;
} *home;

static void VSET_3_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* MaycommTog */
      V9 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* MaycommTog */
      V9 &= ~0x1;
      break;
  }
}
static void VSET_2_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection_MSD */
      V7 |= 0x1;
      break;
    case 2: /* Injecting_MSD */ {
        V8 |= 0x1;
        V6 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection_MSD */
      V7 &= ~0x1;
      break;
    case 2: /* Injecting_MSD */ {
        V8 &= ~0x1;
        V6 &= ~0x1;
        {
        	msdTIMEoldPlot = 0;
        }
      }
      break;
    case 1: /* NotInjecting_MSD */ {
        {
        	ReadMSDionFile( MSDIONFILE );
        } {
        	InitializeMSDeng();
        }
      }
      break;
  }
}
static void VSET_1_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* GCTog */
      V4 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* GCTog */
      V4 &= ~0x1;
      break;
  }
}
static void VSET_0_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection */
      V1 |= 0x1;
      break;
    case 2: /* Injecting */ {
        V5 |= 0x1;
        V2 |= 0x1;
        V0 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection */
      V1 &= ~0x1;
      break;
    case 2: /* Injecting */ {
        V5 &= ~0x1;
        V2 &= ~0x1;
        V0 &= ~0x1;
      }
      break;
  }
}
static void tminitfunc(void) {VSET_0_(1);VSET_1_(1);VSET_2_(1);VSET_3_(1);
}
#define TMINITFUNC tminitfunc()

static void nullfunc(void);
static void BF2_0(void) {
  GC_Ctr_PAN = home->U23.GC_Ctr_PAN;
  GC_Ctr_F11 = home->U25.GC_Ctr_F11;
  GC_Ctr_CO = home->U21.GC_Ctr_CO;
  V3 &= ~0x1;
  {
  
  	for(chanInc=0; chanInc<MAXMSDCHANS; chanInc++) {
  		MSD_ChanX = MSDMISSING;
  		switch( chanInc ) {
  			case 0:
  				MSD_ChanX = home->U23.MSD_Chan0; break;
  			case 1:
  				MSD_ChanX = home->U25.MSD_Chan1; break;
  			case 2:
  				MSD_ChanX = home->U25.MSD_Chan2; break;
  			case 3:
  				MSD_ChanX = home->U25.MSD_Chan3; break;
  			case 4:
  				MSD_ChanX = home->U25.MSD_Chan4; break;
  			case 5:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			case 6:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			case 7:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			default:
  				chanInc = MAXMSDCHANS-1; MSD_ChanX = MSDMISSING; break;
  		}
  
  		if ( MSD_ChanX > 0 ) {
  			msd_sum[chanInc] += MSD_ChanX;
  			MSchanAvg[chanInc]++;
  		}
  	}
  }
}

static void BF32_0(void) {
  BF2_0();
  {if (!(V1)) {
    { CHROMtime += 1; InjectingInc = 0; }
  }if (!(V2)) {
    { 
    	if (InjectingInc == 0 ) {
    		CHROMtime = 1; 
    		InjectingInc = 1;
    	}
    	else CHROMtime += 1;
      }
  }
  }
  {	
  	if (rs485_proxy != 0)  Trigger ( rs485_proxy );
  }
  {
  	if (ECDresp_proxy != 0) Trigger ( ECDresp_proxy );
  }
  {if (!(V4)) {
    { VSET_1_(1);
    	}
  }if (!(V5)) {
    V5 |= 0x1;
    { VSET_1_(2);
    		ecdSF6x = 0.0;
    		ecdF11x = 0.0;
    		ecdCOx  = 0.0;
    		ecdPANx = 0.0;
    	}
  }
  
  	if ( ecdSF6x > NUMSECSXAXIS ) { VSET_1_(2);
  		ecdSF6x = 0.0;
  		ecdF11x = 0.0;
  		ecdCOx  = 0.0;
  		ecdPANx = 0.0;
  	}
  }
  {
  	if ( DetAvgCt1 > 0 ) {
  		ecdA_SF6 = ecd_sum1/DetAvgCt1;
  		ecdA_SF6save = ecdA_SF6;
  		DetAvgCt1 = 0;
  		ecd_sum1 = 0;
  		DetAvgOffline1 = 0;
  	} 
  	else if (( ecdA_SF6save > 0 ) && ( DetAvgOffline1 < 1 )) {
  		DetAvgOffline1++;
  		ecdA_SF6 = ecdA_SF6save;
  	}
  	else {
  		ecdA_SF6 = ECDOFFLINE;
  		ecdA_SF6save = 0;
  	}V11 &= ~0x1;
  if ( DetAvgCt2 > 0 ) {
  		ecdA_F11 = ecd_sum2/DetAvgCt2;
  		ecdA_F11save = ecdA_F11;
  		DetAvgCt2 = 0;
  		ecd_sum2 = 0;
  		DetAvgOffline2 = 0;
  	} 
  	else if (( ecdA_F11save > 0 ) && ( DetAvgOffline2 < 1 )) {
  		DetAvgOffline2++;
  		ecdA_F11 = ecdA_F11save;
  	}
  	else {
  		ecdA_F11 = ECDOFFLINE;
  		ecdA_F11save = 0;
  	}V11 &= ~0x2;
  if ( DetAvgCt3 > 0 ) {
  		ecdA_CO = ecd_sum3/DetAvgCt3;
  		ecdA_COsave = ecdA_CO;
  		DetAvgCt3 = 0;
  		ecd_sum3 = 0;
  		DetAvgOffline3 = 0;
  	} 
  	else if (( ecdA_COsave > 0 ) && ( DetAvgOffline3 < 1 )) {
  		DetAvgOffline3++;
  		ecdA_CO = ecdA_COsave;
  	}
  	else {
  		ecdA_CO = ECDOFFLINE;
  		ecdA_COsave = 0;
  	}V11 &= ~0x4;
  if ( DetAvgCt4 > 0 ) {
  		ecdA_PAN = ecd_sum4/DetAvgCt4;
  		ecdA_PANsave = ecdA_PAN;
  		DetAvgCt4 = 0;
  		ecd_sum4 = 0;
  		DetAvgOffline4 = 0;
  	} 
  	else if (( ecdA_PANsave > 0 ) && ( DetAvgOffline4 < 1 )) {
  		DetAvgOffline4++;
  		ecdA_PAN = ecdA_PANsave;
  	}
  	else {
  		ecdA_PAN = ECDOFFLINE;
  		ecdA_PANsave = 0;
  	}V11 &= ~0x8;
  }
  {
   	++CUMSEC;
  }
  {
  	if ( MSchanAvg[0] > 0 ) {
  		msdA_0 = msd_sum[0]/MSchanAvg[0];
  		MSchanAvg[0] = msd_sum[0] = 0;
  	} else {
  		msdA_0 = MSDOFFLINE;
  	}V11 &= ~0x10;
  if ( MSchanAvg[1] > 0 ) {
  		msdA_1 = msd_sum[1]/MSchanAvg[1];
  		MSchanAvg[1] = msd_sum[1] = 0;
  	} else {
  		msdA_1 = MSDOFFLINE;
  	}V11 &= ~0x20;
  if ( MSchanAvg[2] > 0 ) {
  		msdA_2 = msd_sum[2]/MSchanAvg[2];
  		MSchanAvg[2] = msd_sum[2] = 0;
  	} else {
  		msdA_2 = MSDOFFLINE;
  	}V11 &= ~0x40;
  if ( MSchanAvg[3] > 0 ) {
  		msdA_3 = msd_sum[3]/MSchanAvg[3];
  		MSchanAvg[3] = msd_sum[3] = 0;
  	} else {
  		msdA_3 = MSDOFFLINE;
  	}V11 &= ~0x80;
  if ( MSchanAvg[4] > 0 ) {
  		msdA_4 = msd_sum[4]/MSchanAvg[4];
  		MSchanAvg[4] = msd_sum[4] = 0;
  	} else {
  		msdA_4 = MSDOFFLINE;
  	}V11 &= ~0x100;
  if ( MSchanAvg[5] > 0 ) {
  		msdA_5 = msd_sum[5]/MSchanAvg[5];
  		MSchanAvg[5] = msd_sum[5] = 0;
  	} else {
  		msdA_5 = MSDOFFLINE;
  	}V11 &= ~0x200;
  if ( MSchanAvg[6] > 0 ) {
  		msdA_6 = msd_sum[6]/MSchanAvg[6];
  		MSchanAvg[6] = msd_sum[6] = 0;
  	} else {
  		msdA_6 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[7] > 0 ) {
  		msdA_7 = msd_sum[7]/MSchanAvg[7];
  		MSchanAvg[7] = msd_sum[7] = 0;
  	} else {
  		msdA_7 = MSDOFFLINE;
  	}
  
  }
  {if (!(V7)) {
    { 
    	MSDchromtime += 1; 
    	InjectingInc_MSD = 0;
      }
  }if (!(V8)) {
    { 
    	if ( InjectingInc_MSD == 0 ) {
    		MSDchromtime = 1; 
    		InjectingInc_MSD = 1;
    	} else 
    		MSDchromtime += 1;
      }
  }
  }
  {
  	if (maycomm_proxy != 0)  Trigger ( maycomm_proxy );
  }
}

static void EF2_1(void) {
  if (!(V3)) {
    {
    	if (home->U0.GC_Ctr_SF6 >= 0) {
    		ecd_sum1 += home->U0.GC_Ctr_SF6;
    		DetAvgCt1++;
    		ecdSF6x += ELECRATE;
    	} 
    	if (GC_Ctr_F11 >= 0) {
    		ecd_sum2 += GC_Ctr_F11;
    		DetAvgCt2++;
    		ecdF11x += ELECRATE;
    	}
    	if (GC_Ctr_CO >= 0) {
    		ecd_sum3 += GC_Ctr_CO;
    		DetAvgCt3++;
    		ecdCOx += ELECRATE;
    	}
    	if (GC_Ctr_PAN >= 0) {
    		ecd_sum4 += GC_Ctr_PAN;
    		DetAvgCt4++;
    		ecdPANx += ELECRATE;
    	}
    }
  }
}

static void BF32_1(void) {
  PresMS1 = home->U0.PresMS1;
  PresMS2 = home->U1.PresMS2;
  PresBP_5 = home->U9.PresBP_5;
  PresE_5 = home->U11.PresE_5;
  VoltMS1 = home->U9.VoltMS1;
  VoltMS2 = home->U9.VoltMS2;
  VoltBP_5 = home->U9.VoltBP_5;
  VoltE_5 = home->U7.VoltE_5;
  V11 &= ~0x4000;
  EF2_1();
}

static void BF32_3(void) {
  FlowM_CO = home->U1.FlowM_CO;
  FlowB_CO = home->U3.FlowB_CO;
  PresBP_CO = home->U1.PresBP_CO;
  PresE_CO = home->U0.PresE_CO;
  VoltM_CO = home->U0.VoltM_CO;
  VoltB_CO = home->U0.VoltB_CO;
  VoltBP_CO = home->U1.VoltBP_CO;
  VoltE_CO = home->U0.VoltE_CO;
  ColT_MS2 = home->U3.ColT_MS2;
  ColT_MS1 = home->U3.ColT_MS1;
  V11 &= ~0x400;
  EF2_1();
}

static void BF32_5(void) {
  FlowM_F11 = home->U5.FlowM_F11;
  FlowB_F11 = home->U7.FlowB_F11;
  PresBP_F11 = home->U5.PresBP_F11;
  PresE_F11 = home->U3.PresE_F11;
  VoltM_F11 = home->U3.VoltM_F11;
  VoltB_F11 = home->U3.VoltB_F11;
  VoltBP_F11 = home->U5.VoltBP_F11;
  VoltE_F11 = home->U1.VoltE_F11;
  ColT_PAN = home->U5.ColT_PAN;
  V11 &= ~0x1000;
  EF2_1();
  home->U25.maycX++;
  {if (!(V9)) {
    { VSET_3_(1); }
  }
  
  	if ( home->U25.maycX >= 120 ) { 
  		home->U25.maycX = 0; VSET_3_(2);
  	}
  }
}

static void BF32_7(void) {
  Pres1_PAN = home->U7.Pres1_PAN;
  Pres2_PAN = home->U9.Pres2_PAN;
  PresSrc_PAN = home->U7.PresSrc_PAN;
  PresE_PAN = home->U7.PresE_PAN;
  FlowSrc_PAN = home->U5.FlowSrc_PAN;
  VoltM_PAN = home->U5.VoltM_PAN;
  VoltB_PAN = home->U7.VoltB_PAN;
  VoltE_PAN = home->U3.VoltE_PAN;
  Pow_p12 = home->U15.Pow_p12;
  Pow_m15 = home->U17.Pow_m15;
  V11 &= ~0x2000;
  EF2_1();
}

static void BF32_9(void) {
  FlowM_SF6 = home->U0.FlowM_SF6;
  FlowB_SF6 = home->U3.FlowB_SF6;
  PresBP_SF6 = home->U5.PresBP_SF6;
  PresE_SF6 = home->U3.PresE_SF6;
  VoltM_SF6 = home->U1.VoltM_SF6;
  VoltB_SF6 = home->U1.VoltB_SF6;
  VoltBP_SF6 = home->U1.VoltBP_SF6;
  VoltE_SF6 = home->U3.VoltE_SF6;
  Pow_p15 = home->U17.Pow_p15; {
    V11 &= ~0x800;
    V10 &= ~0x2;
  }
  EF2_1();
}

static void BF32_11(void) {
  tdlP = home->U23.tdlP;
  tdlsH2O = home->U35.tdlsH2O;
  tdllH2O = home->U35.tdllH2O;
  Pow_p15pel2 = home->U13.Pow_p15pel2;
  Pow_p15pel1 = home->U15.Pow_p15pel1; {
    V12 &= ~0x40;
    V10 &= ~0x1;
  }
  EF2_1();
}

static void BF32_13(void) {
  Flow_MSsl = home->U13.Flow_MSsl;
  Flow_Packsl = home->U13.Flow_Packsl;
  Flow_PANsl = home->U13.Flow_PANsl;
  Pow_p28pri = home->U11.Pow_p28pri;
  Pow_p24ms = home->U19.Pow_p24ms;
  Pow_p24gsv = home->U17.Pow_p24gsv;
  V12 &= ~0x20;
  EF2_1();
}

static void BF32_15(void) {
  PresH_N2 = home->U5.PresH_N2;
  PresH_He = home->U7.PresH_He;
  PresH_CO2 = home->U11.PresH_CO2;
  PresH_Cal2 = home->U15.PresH_Cal2;
  PresH_Cal1 = home->U15.PresH_Cal1;
  PresBP_PAN = home->U5.PresBP_PAN;
  Pres_SL = home->U11.Pres_SL;
  Pres_Inlet = home->U11.Pres_Inlet;
  Pow_p5 = home->U15.Pow_p5;
  Pow_p28sec = home->U11.Pow_p28sec;
  V11 &= ~0x8000;
  EF2_1();
}

static void BF32_17(void) {
  PresL_He = home->U7.PresL_He;
  PresL_CO2 = home->U9.PresL_CO2;
  PresL_Cal2 = home->U13.PresL_Cal2;
  PresL_Cal1 = home->U17.PresL_Cal1;
  PresHead_P = home->U0.PresHead_P;
  PresH_ZA = home->U15.PresH_ZA;
  PresH_PAN = home->U13.PresH_PAN;
  PresH_N2O = home->U13.PresH_N2O;
  V12 &= ~0x1;
  EF2_1();
}

static void BF32_19(void) {
  Temp_elect = home->U9.Temp_elect;
  Temp_COsl = home->U11.Temp_COsl;
  PresL_ZA = home->U15.PresL_ZA;
  PresL_PAN = home->U15.PresL_PAN;
  PresL_N2O = home->U11.PresL_N2O;
  PresL_N2 = home->U7.PresL_N2;
  V12 &= ~0x2;
  EF2_1();
  if (!(V10)) {
    {
    //	P = ((PresE_SF6) - 30);
        P = (tdlP);
    //	home->U33.tdlbH2O = tdllH2O / ( 1.15 - 0.0008123 * P + 5.283e-7 * P*P ) - 1.5;
    	home->U33.tdlbH2O = tdllH2O / ( 1.135 - 0.000757 * P + 5.372e-7 * P*P );
    //	home->U33.tdlbH2O = (tdllH2O * 1.36) -4.9;
    	
    	if ( tdllH2O > USELONGPATH ) home->U33.tdlbH2O = tdlsH2O - OffsetShortPath;
    }
  }
}

static void BF32_21(void) {
  Trap1_re = home->U1.Trap1_re;
  Temp_stack = home->U13.Temp_stack;
  Temp_SF6sl = home->U15.Temp_SF6sl;
  Temp_PANsrc = home->U19.Temp_PANsrc;
  Temp_PANsl = home->U17.Temp_PANsl;
  Temp_PANlmp = home->U17.Temp_PANlmp;
  Temp_Ipump = home->U17.Temp_Ipump;
  Temp_GSVbo = home->U17.Temp_GSVbo;
  Temp_GasBot = home->U13.Temp_GasBot;
  Temp_F11sl = home->U9.Temp_F11sl;
  V12 &= ~0x4;
  EF2_1();
}

static void BF32_23(void) {
  F11_ECD_Sp = home->U19.F11_ECD_Sp;
  F11_ECD = home->U19.F11_ECD;
  F11_Col_Sp = home->U21.F11_Col_Sp;
  F11_Col = home->U21.F11_Col;
  CO_ECD_Sp = home->U23.CO_ECD_Sp;
  CO_ECD = home->U23.CO_ECD;
  CO_Col_Sp = home->U21.CO_Col_Sp;
  CO_Col = home->U21.CO_Col;
  VoltBP_PAN = home->U7.VoltBP_PAN;
  Trap2_set = home->U9.Trap2_set;
  Trap2_re = home->U9.Trap2_re;
  Trap1_set = home->U5.Trap1_set;
  V12 &= ~0x8;
  EF2_1();
  { ITXFileNum = home->U0.CurrInj * 1000 + home->U0.CurrFile;
  }
}

static void BF32_25(void) {
  SF6_ECD_Sp = home->U21.SF6_ECD_Sp;
  SF6_ECD = home->U21.SF6_ECD;
  SF6_Col_Sp = home->U23.SF6_Col_Sp;
  SF6_Col = home->U23.SF6_Col;
  PAN_ECD_Sp = home->U21.PAN_ECD_Sp;
  PAN_ECD = home->U21.PAN_ECD;
  V12 &= ~0x10;
  EF2_1();
}

static void BF32_27(void) {
  EF2_1();
  if (!(V0)) {
    {
      if ( home->U19.GCstate == 2 ) VSET_0_(3);
    }
  }
    else {
      if ( home->U19.GCstate == 1 ) VSET_0_(2);
      if ( home->U19.GCstate == 0 ) VSET_0_(1);
    }
  {
  		MSDstateS = home->U19.MSDstate;
  	}
  if (!(V6)) {
    {
      if ( home->U19.MSDstate == 2 ) VSET_2_(3);
    }
  }
    else {
      if ( home->U19.MSDstate == 1 ) VSET_2_(2);
      else if ( home->U19.MSDstate == 0 ) VSET_2_(1);
    }
  if (!(V12||V11)) {
    {
      ss_insert_value(eng, dtime()+ext_delta, 0);
      ss_set(eng, 1, FlowM_CO);
      ss_set(eng, 2, FlowB_CO);
      ss_set(eng, 3, PresBP_CO);
      ss_set(eng, 4, PresE_CO);
      ss_set(eng, 5, VoltM_CO);
      ss_set(eng, 6, VoltB_CO);
      ss_set(eng, 7, VoltBP_CO);
      ss_set(eng, 8, VoltE_CO);
      ss_set(eng, 9, FlowM_SF6);
      ss_set(eng, 10, FlowB_SF6);
      ss_set(eng, 11, PresBP_SF6);
      ss_set(eng, 12, PresE_SF6);
      ss_set(eng, 13, VoltM_SF6);
      ss_set(eng, 14, VoltB_SF6);
      ss_set(eng, 15, VoltBP_SF6);
      ss_set(eng, 16, VoltE_SF6);
      ss_set(eng, 17, FlowM_F11);
      ss_set(eng, 18, FlowB_F11);
      ss_set(eng, 19, PresBP_F11);
      ss_set(eng, 20, PresE_F11);
      ss_set(eng, 21, VoltM_F11);
      ss_set(eng, 22, VoltB_F11);
      ss_set(eng, 23, VoltBP_F11);
      ss_set(eng, 24, VoltE_F11);
      ss_set(eng, 25, Pres1_PAN);
      ss_set(eng, 26, Pres2_PAN);
      ss_set(eng, 27, PresSrc_PAN);
      ss_set(eng, 28, PresE_PAN);
      ss_set(eng, 29, VoltM_PAN);
      ss_set(eng, 30, VoltB_PAN);
      ss_set(eng, 31, FlowSrc_PAN);
      ss_set(eng, 32, VoltE_PAN);
      ss_set(eng, 33, PresMS1);
      ss_set(eng, 34, PresMS2);
      ss_set(eng, 35, PresBP_5);
      ss_set(eng, 36, PresE_5);
      ss_set(eng, 37, VoltMS1);
      ss_set(eng, 38, VoltMS2);
      ss_set(eng, 39, VoltBP_5);
      ss_set(eng, 40, VoltE_5);
      ss_set(eng, 41, Pres_SL);
      ss_set(eng, 42, Pres_Inlet);
      ss_set(eng, 43, PresH_CO2);
      ss_set(eng, 44, PresH_N2O);
      ss_set(eng, 45, PresH_ZA);
      ss_set(eng, 46, PresH_PAN);
      ss_set(eng, 47, PresH_Cal2);
      ss_set(eng, 48, PresH_Cal1);
      ss_set(eng, 49, PresH_He);
      ss_set(eng, 50, PresH_N2);
      ss_set(eng, 51, PresL_CO2);
      ss_set(eng, 52, PresL_N2O);
      ss_set(eng, 53, PresL_ZA);
      ss_set(eng, 54, PresL_PAN);
      ss_set(eng, 55, PresL_Cal2);
      ss_set(eng, 56, PresL_Cal1);
      ss_set(eng, 57, PresL_He);
      ss_set(eng, 58, PresL_N2);
      ss_set(eng, 59, Temp_F11sl);
      ss_set(eng, 60, Temp_SF6sl);
      ss_set(eng, 61, Temp_COsl);
      ss_set(eng, 62, Temp_GSVbo);
      ss_set(eng, 63, Temp_elect);
      ss_set(eng, 64, Temp_PANsl);
      ss_set(eng, 65, Temp_stack);
      ss_set(eng, 66, Temp_Ipump);
      ss_set(eng, 67, (F11_Col*1E-1));
      ss_set(eng, 68, (CO_Col*1E-1));
      ss_set(eng, 69, (SF6_Col*1E-1));
      ss_set(eng, 70, (home->U15.SF6_Post*1E-1));
      ss_set(eng, 71, (F11_ECD*1E-1));
      ss_set(eng, 72, (CO_ECD*1E-1));
      ss_set(eng, 73, (SF6_ECD*1E-1));
      ss_set(eng, 74, (PAN_ECD*1E-1));
      ss_set(eng, 75, (home->U19.Trap1_CB*1E-1));
      ss_set(eng, 76, (home->U23.Trap2_CB*1E-1));
      ss_set(eng, 77, (F11_Col_Sp*1E-1));
      ss_set(eng, 78, (CO_Col_Sp*1E-1));
      ss_set(eng, 79, (SF6_Col_Sp*1E-1));
      ss_set(eng, 80, (home->U15.SF6_Post_Sp*1E-1));
      ss_set(eng, 81, (F11_ECD_Sp*1E-1));
      ss_set(eng, 82, (CO_ECD_Sp*1E-1));
      ss_set(eng, 83, (SF6_ECD_Sp*1E-1));
      ss_set(eng, 84, (PAN_ECD_Sp*1E-1));
      ss_set(eng, 85, (home->U21.Trap1_CB_Sp*1E-1));
      ss_set(eng, 86, (home->U23.Trap2_CB_Sp*1E-1));
      ss_set(eng, 87, Pow_p28pri);
      ss_set(eng, 88, Pow_p28sec);
      ss_set(eng, 89, Pow_p15pel1);
      ss_set(eng, 90, Pow_p15pel2);
      ss_set(eng, 91, Pow_p12);
      ss_set(eng, 92, Pow_m15);
      ss_set(eng, 93, Pow_p15);
      ss_set(eng, 94, Pow_p5);
      ss_set(eng, 95, Pow_p24gsv);
      ss_set(eng, 96, Pow_p24ms);
      ss_set(eng, 97, Flow_MSsl);
      ss_set(eng, 98, Flow_Packsl);
      ss_set(eng, 99, Flow_PANsl);
      ss_set(eng, 100, ecdA_SF6);
      ss_set(eng, 101, ecdA_F11);
      ss_set(eng, 102, ecdA_CO);
      ss_set(eng, 103, ecdA_PAN);
      ss_set(eng, 104, msdA_0);
      ss_set(eng, 105, msdA_1);
      ss_set(eng, 106, msdA_2);
      ss_set(eng, 107, msdA_3);
      ss_set(eng, 108, msdA_4);
      ss_set(eng, 109, msdA_5);
      ss_set(eng, 110, ColT_MS1);
      ss_set(eng, 111, ColT_MS2);
      ss_set(eng, 112, ColT_PAN);
      ss_set(eng, 113, Trap1_set);
      ss_set(eng, 114, Trap1_re);
      ss_set(eng, 115, Trap2_set);
      ss_set(eng, 116, Trap2_re);
      ss_set(eng, 117, PresBP_PAN);
      ss_set(eng, 118, VoltBP_PAN);
      ss_set(eng, 119, PresHead_P);
      ss_set(eng, 120, Temp_PANsrc);
      ss_set(eng, 121, Temp_PANlmp);
      ss_set(eng, 122, Temp_GasBot);
    }
  }
}

static void (*efuncs[64])() = {
  BF32_0,
  BF32_1,
  BF2_0,
  BF32_3,
  BF2_0,
  BF32_5,
  BF2_0,
  BF32_7,
  BF2_0,
  BF32_9,
  BF2_0,
  BF32_11,
  BF2_0,
  BF32_13,
  BF2_0,
  BF32_15,
  BF2_0,
  BF32_17,
  BF2_0,
  BF32_19,
  BF2_0,
  BF32_21,
  BF2_0,
  BF32_23,
  BF2_0,
  BF32_25,
  BF2_0,
  BF32_27,
  BF2_0,
  EF2_1,
  BF2_0,
  EF2_1,
  BF32_0,
  BF32_1,
  BF2_0,
  BF32_3,
  BF2_0,
  BF32_5,
  BF2_0,
  BF32_7,
  BF2_0,
  BF32_9,
  BF2_0,
  BF32_11,
  BF2_0,
  BF32_13,
  BF2_0,
  BF32_15,
  BF2_0,
  BF32_17,
  BF2_0,
  BF32_19,
  BF2_0,
  BF32_21,
  BF2_0,
  BF32_23,
  BF2_0,
  BF32_25,
  BF2_0,
  BF32_27,
  BF2_0,
  EF2_1,
  BF2_0,
  EF2_1
};

static void IVF2_0(void) {
  V3 |= 0x1;
}
static void IVF32_1(void) {
  V11 |= 0x4000;
}
static void IVF32_3(void) {
  V11 |= 0x400;
}
static void IVF32_5(void) {
  V11 |= 0x1000;
}
static void IVF32_7(void) {
  V11 |= 0x2000;
}
static void IVF32_9(void) { {
    V11 |= 0x800;
    V10 |= 0x2;
  }
}
static void IVF32_11(void) { {
    V12 |= 0x40;
    V10 |= 0x1;
  }
}
static void IVF32_13(void) {
  V12 |= 0x20;
}
static void IVF32_15(void) {
  V11 |= 0x8000;
}
static void IVF32_17(void) {
  V12 |= 0x1;
}
static void IVF32_19(void) {
  V12 |= 0x2;
}
static void IVF32_21(void) {
  V12 |= 0x4;
}
static void IVF32_23(void) {
  V12 |= 0x8;
}
static void IVF32_25(void) {
  V12 |= 0x10;
}
#define IVFUNCS
static void (*ivfuncs[64])() = {
  IVF2_0,
  IVF32_1,
  IVF2_0,
  IVF32_3,
  IVF2_0,
  IVF32_5,
  IVF2_0,
  IVF32_7,
  IVF2_0,
  IVF32_9,
  IVF2_0,
  IVF32_11,
  IVF2_0,
  IVF32_13,
  IVF2_0,
  IVF32_15,
  IVF2_0,
  IVF32_17,
  IVF2_0,
  IVF32_19,
  IVF2_0,
  IVF32_21,
  IVF2_0,
  IVF32_23,
  IVF2_0,
  IVF32_25,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_1,
  IVF2_0,
  IVF32_3,
  IVF2_0,
  IVF32_5,
  IVF2_0,
  IVF32_7,
  IVF2_0,
  IVF32_9,
  IVF2_0,
  IVF32_11,
  IVF2_0,
  IVF32_13,
  IVF2_0,
  IVF32_15,
  IVF2_0,
  IVF32_17,
  IVF2_0,
  IVF32_19,
  IVF2_0,
  IVF32_21,
  IVF2_0,
  IVF32_23,
  IVF2_0,
  IVF32_25,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc
};

static void nullfunc(void){}
#define TRN 320
#define TRD 1
#define LOWLIM (-2880)
#define HIGHLIM (2880)
#define NBROW 48
#define NROWMINF 1
#define NSECSPER 1
#define NROWSPER 32
#define SYNCHVAL 0xABB4
#define NROWMAJF 64
#define MFSECNUM 32
#define MFSECDEN 1
#define SECDRIFT 90
#define COPY_MFCtr
#define MFCtr home->U0.MFCtr

#ifndef EXTRACTION_INIT
  #define EXTRACTION_INIT
#endif
#ifndef OPT_EXT_INIT
  #define OPT_EXT_INIT
#endif
#ifndef EXTRACTION_TERM
  #define EXTRACTION_TERM
#endif
#ifndef TMINITFUNC
  #define TMINITFUNC
#endif

static unsigned int next_minor_frame, majf_row;
#if (NROWMINF != 1)
  static unsigned int minf_row = 0;
#endif
#ifdef NEED_TIME_FUNCS
  static unsigned short CurMFC;
#endif


void main(int argc, char **argv) {
  oui_init_options(argc, argv);

  TMINITFUNC;
  BEGIN_MSG;
  EXTRACTION_INIT;
  DC_operate();
  EXTRACTION_TERM;
  DONE_MSG;
}


#define MKDCTV(x,y) ((x<<8)|y)
#define DCTV(x,y) MKDCTV(DCT_##x,DCV_##y)

/* The main thing we need to do is reset our row counter on TM START */
void DC_DASCmd(unsigned char type, unsigned char val) {
  switch (MKDCTV(type, val)) {
	case DCTV(TM,TM_START):
	  next_minor_frame = majf_row = 0;
	  #if (NROWMINF != 1)
		minf_row = 0;
	  #endif
	  break;
	case DCTV(TM,TM_END):
	case DCTV(QUIT,QUIT):
	default:
	  break;
  }
}

#define incmod(x,y) if (x==((y)-1)) x = 0; else x++

void DC_data(dbr_data_type *dr_data) {
  unsigned short nrows;

  for (nrows = dr_data->n_rows, home = (void *) &dr_data->data[0];
	   nrows > 0;
	   nrows--, home ++) {

	/* First check the minor frame counter if necessary */
	#if (NROWMINF != 1)
	if (minf_row == 0) {
	#endif
	  COPY_MFCtr /* Needs to be defined by TMC */
	  #ifdef NEED_TIME_FUNCS
		CurMFC = MFCtr;
	  #endif
	  {
		unsigned short delta;
		
		delta = MFCtr - next_minor_frame;
		if (delta != 0) {
		  #ifdef IVFUNCS
			if (delta > NROWMAJF/NROWMINF) delta = NROWMAJF;
			else delta *= NROWMINF;
			/* delta is now the number of rows skipped up to a maximum of
			  nrowmajf. While invalidating, I don't need to update
			  minf_row, since the final will be 0, same as before.
			  MFCtr is already set, and majf_row is updated.
			*/
			while (delta-- > 0)
			  ivfuncs[majf_row]();
		  #endif
		  majf_row = (((unsigned short)MFCtr) % (NROWMAJF/NROWMINF))
							  * NROWMINF;
		}
	  }
	  next_minor_frame = MFCtr+1;
	#if (NROWMINF != 1)
	}
	#endif
	
	/* Now process the row */
	efuncs[majf_row]();
	incmod(majf_row, NROWMAJF);
	#if (NROWMINF != 1)
	  incmod(minf_row, NROWMINF);
	#endif
  }
}

#ifdef __WATCOMC__
  #pragma off (unreferenced)
#endif

void DC_tstamp(tstamp_type *tstamp) { /* Nothing to do! */ }

void DC_other(unsigned char *msg_ptr, int sent_tid) {
  unsigned char rep_msg = DAS_UNKN;

  Reply(sent_tid, &rep_msg, 1);
}

#ifdef __WATCOMC__
  #pragma on (unreferenced)
#endif

#ifdef NEED_TIME_FUNCS
  #if (NROWMINF != 1)
	#define ROWS(x) (((unsigned long)(x))*NROWMINF+minf_row)
  #else
	#define ROWS(x) (x)
  #endif
  #if (NSECSPER != 1)
	#define FRACSECS(x) (((unsigned long)ROWS(x))*NSECSPER)
  #else
	#define FRACSECS(x) ROWS(x)
  #endif
  long itime(void) {
	  return(dbr_info.t_stmp.secs +
		FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double dtime(void) {
	  return(dbr_info.t_stmp.secs +
		(double) FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double etime(void) {
	double t;
	static double t0 = -1e9;
	
	t = dtime();
	if (t0 == -1e9) t0 = t;
	return(t - t0);
  }
#endif

dbr_info_type dbr_info = {
  "", /* tmid */
  48, /* NBMINF */
  48, /* NBROW */
  64, /* NROWSMAJF */
  1, /* NSECSPER */
  32, /* NROWSPER */
  0, 1, /* MFC lsb col, msb col */
  0xABB4, /* Synch Value */
  0 /* not inverted */
};
